#include "netmap.h"
#include <sys/file.h>

/* ----------------------------------------------------------------------
   Read and process a canned PostScript map file.
 */



getPSmap(name,argv)
char	*name,**argv;
{
	FILE	*Ifile;
	char	lbuf[256],t1[50];
	int	nfin;
	fprintf(stderr,"Using canned map file %s\n",name);

	Ifile = fopen(name,"r");
	if (Ifile == NULL) {
	    perror(name);
	    exit(3);
	}
	if(NULL==fgets(lbuf,256,Ifile)) goto ioerr;
	if (strcmp(lbuf,"%!\n")) {
	    fprintf(stderr,"%s is not a PostScript file.\n",name);
	    goto xit1;
	}
	if(NULL==fgets(lbuf,256,Ifile)) goto ioerr;
	if (strncmp(lbuf,"% netmap", 8)) {
	    fprintf(stderr,"File %s was not created by netmap.\n",name);
	    goto xit1;
	}
	sscanf(lbuf,"%% %s",t1);
	if (strcmp(t1,ProgID)) {
	    fprintf(stderr,"Version mismatch: File %s was created by %s; this is %s.\nCannot continue.\n",name,t1,ProgID);
	    goto xit1;
	}

	if(NULL==fgets(lbuf,256,Ifile)) goto ioerr;
	if (strncmp(lbuf,"%%CMAP ",7)) {
	    fprintf(stderr,"Format error in %s: %%%%CMAP line missing\n",name);
	    goto xit1;
	}

/* Here goes nothing! Watch out! */
        nfin = sscanf(lbuf,"%s%lf%lf%lf%lf%lf%d%d%d%lf%lf%d%d%d%d%d",
			t1,
	    		&LatCenter,&LongCenter,&LatHeight,&LongWidth,&MapScale,
			&StrokeLimit,&RotDegrees,&Projection,&Lamb1,&Lamb2,
			&DeviceResolution,&PageHeight,&PageWidth,&PageMargin,
			&CaptionMargin);
	if (nfin != 16) {
	    fprintf(stderr,"File %s: expected 16 fields in setup line; found %d. This is a\nlogic error in netmap or else you have mucked with the file.\n",
	        name,nfin);
	    goto xit1;
	}
	UsingCanned = TRUE;
	MinimumStrokeSize = StrokeLimit*StrokeLimit;
	init(argv);

/* Now copy the map body itself */
	while (fgets(lbuf, 256, Ifile)) {
	    fputs(lbuf,stdout);
	}

	fclose(Ifile);
	return;
ioerr: fprintf(stderr,"I/O error reading%s:\n",name);
       if (errno) perror("status: ");
          else    fprintf(stderr,"premature EOF\n");
 	exit(3);
xit1: fclose(Ifile);
      exit(3);
}
