#include "netmap.h"

#define	LatGridRes	50
#define LongGridRes	50

drawgrids () {
    int	    i,inrange,unmarked,gridlock,ix,ixincr;
    double    x,xa,xx,yy,px,py,x0,y0,tx,ty,
	     GridLatMin,GridLongMin,GridLatMax,GridLongMax,
	     LatSecsMin,LatSecsMax,LongSecsMin,LongSecsMax;

#define	nlockpts 9
    static int lockpts[nlockpts+1]={0,1,5,10,60,300,600,3600,18000,36000};

    if (gridincr <= 0) return;
    ixincr = gridincr * 3600.;
    gridlock=   1;
    for (i = 0; i < nlockpts; i++)
        if (ixincr > lockpts[i]) gridlock=lockpts[i+1];

    LatSecsMin = gridlock*((int) (RoughLatMin*3600)/gridlock);
    LatSecsMax = gridlock*((int) (RoughLatMax*3600)/gridlock);
    if (LatSecsMin < 0) LatSecsMin -= gridlock;
    if (LatSecsMax > 0) LatSecsMax += gridlock;
    
    if (CrossDateline) {
	LongSecsMin= -180.*3600.;
	LongSecsMax=180.*3600.;
    } else {
        LongSecsMin=gridlock*((int) (RoughLongMin*3600)/gridlock);
	LongSecsMax=gridlock*((int) (RoughLongMax*3600)/gridlock);
	if (LongSecsMin < 0) LongSecsMin -= gridlock;
	if (LongSecsMax > 0) LongSecsMax += gridlock;
    }
    GridLatMin = LatSecsMin / 3600.;
    GridLatMax = LatSecsMax / 3600.;
    GridLongMin = LongSecsMin / 3600.;
    GridLongMax = LongSecsMax / 3600.;
    setupLine(LineWidth,LineColor);
    Exact = TRUE;
    
    for (ix = LatSecsMin; ix <= LatSecsMax; ix += ixincr) {
	x = ix / 3600.;
	unmarked = TRUE;
	project(x,GridLongMin,&x0,&y0);
	if (clipxy(x0,y0)) {
	    PSP(x0,y0,"NP MP");
	    printf("Nlw SLW ");
	    inrange=TRUE;
	} else inrange=FALSE;
	xx = x0; yy = y0;
	for (i=1; i<=LatGridRes; i++) {
	    px = xx; py = yy;
#ifdef GOOD_COMPILER
	    project(x, xa=GridLongMin+(i*(GridLongMax-GridLongMin)/LatGridRes),&xx,&yy);
#else
	    /* The above breaks the Sun 3.0 compiler under -f68881.  Phoo! */
	    xa=GridLongMin+(i*(GridLongMax-GridLongMin)/LatGridRes);
	    project(x, xa, &xx, &yy);
#endif
	    if (clipxy(xx,yy)) {
	        if (!inrange) {
		    atclip(xx,yy,px,py,&x0,&y0);
		    PSP(x0,y0,"NP MP"); inrange=TRUE;
		    printf("Nlw SLW ");
		}
		LSP(xx-x0,yy-y0);
	    } else {if (inrange) {
			atclip(px,py,xx,yy,&tx,&ty);
			LSP(tx-x0,ty-y0);
			FlushLSP(TRUE);
			printf("ST\n"); inrange=FALSE;
	    	       }
	    }
	    if (inrange && unmarked) {
	    	double eangle;
	        unmarked = FALSE;
		FlushLSP(TRUE);
		PP(xx-x0,yy-y0);
		eangle=degs(atan2(yy-py,xx-px));
		printf("GMCT (%s) %4.1f RSG\n",prll(x,1,1),eangle);
	    }
	}
	if (inrange) {
	    FlushLSP(TRUE);
	    printf("ST\n");
	}
    }

    
    for (ix = LongSecsMin; ix <= LongSecsMax; ix += ixincr) {
	x = ix / 3600.;
	project(GridLatMin,x,&x0,&y0);
	unmarked = TRUE;
	if (clipxy(x0,y0)) {
	    PSP(x0,y0,"NP MP");
	    printf("Nlw SLW ");
	    inrange=TRUE;
	} else inrange=FALSE;
	xx = x0; yy = y0;
	for (i=1; i<=LongGridRes; i++) {
	    px=xx; py=yy;
#ifdef GOOD_COMPILER
	    project(xa=GridLatMin+(i*(GridLatMax-GridLatMin)/LongGridRes),x,&xx,&yy);
#else
	    /* The above breaks the Sun 3.0 compiler under -f68881.  Phoo! */
	    xa=GridLatMin+(i*(GridLatMax-GridLatMin)/LongGridRes);
	    project(xa,x,&xx,&yy);
#endif
	    if (clipxy(xx,yy)) {
	        if (!inrange) {
		    atclip(xx,yy,px,py,&x0,&y0);
		    PSP(x0,y0,"NP MP"); inrange=TRUE;
		    printf("Nlw SLW ");
		}
		LSP(xx-x0,yy-y0);
	    } else {if (inrange) {
	    		atclip(px,py,xx,yy,&tx,&ty);
	                LSP(tx-x0,ty-y0);
			FlushLSP(TRUE);
			printf("ST\n"); inrange=FALSE;
	    	       }
	    }
	    if (inrange && unmarked) {
	    	double eangle;
	        unmarked = FALSE;
		FlushLSP(TRUE);
		PP(xx-x0,yy-y0);
		eangle=degs(atan2(yy-py,xx-px));
		printf("GMCT (%s) %4.1f RSG\n",prll(x,-1,1),eangle);
	    }
	}
	if (inrange) {
	    FlushLSP(TRUE);
	    printf("ST\n");
	}
    }
    Exact = FALSE;
}
