/* 
Header file for netmap. Brian Reid, DEC Western Research, Sept. 1986

 */
#define DEBUG
#define	MAXHOSTS 60000
#define	HNAMELEN 9		/* number of characters kept in host name */
#define	LIBDIR	"/udir/reid/maps/src"

/* You probably don't want to change anything below this line */
#include <stdio.h>
#include <math.h>
#include <ctype.h>

#define	pi	3.14159265
#define halfpi	1.57079632
#define	TRUE	1
#define	FALSE	0

#define rads(x) (pi*(x)/180.0)
#define degs(x) (180.0*(x)/pi)
#define abs(x)	((x)<0 ? -(x) : (x))
#define sign(x) ((x>=0) ? 1 : -1)

/* values for "Projection" */
#define Lambert	1
#define	Mercator 2
#define Gall	3
#define CentralCyl 4

/* values for "HostLabels" */
#define Circles	1
#define	Dots	2
#define	LabelDots 3
#define TrafficCircles 4
#define TextDots 012
#define TextCircles 011
#define TextTraffic 014

/* values for "Drawn" */
#define DecideByTraffic 0
#define DrawDot 1
#define NodeDrawn 2
#define	DrawCircle 3
#define DecideTextTraffic 010
#define DrawTextDot 011
#define DrawTextCircle 013
#define	DrawDefault DrawDot


/* values for the host placement slot grid */
#define	slot(a,b)	(cmap)[xslot(a) + (4+XSlots)*yslot(b)]
#define	slotix(a,b)	(cmap)[(a) + (4+XSlots)*b]

/* Data structure to hold node-to-node paths */
    struct hpath {
        struct hpath *next;
	int  oindex,dindex,pwidth,pcolor,passno;
    } *pathTop;

/* Data structure to hold the table of node names */
    struct hn {
	struct hn *cnext;
    	char hname[HNAMELEN+1];
	unsigned char inbounds,drawn,datacomplete;
	long inTraf,outTraf,hid;
	long cpoints;
	double hstx,hsty;
	struct hpath *paths;
    } htable[MAXHOSTS];

/* Global procedures and variables */
extern char 	*prll(),
		sdat[],
		*MapTitle,
		*MapSubtitle;

extern double 	trunc();	/* oddly enough, this is not declared in math.h */
extern int
		BiDirectional,
		BigImage,
		CacheActive,
	 	CannedMap,
		clipframe,
		clipxy(),
		CrossDateline,
		DebugLevel,
		DeviceResolution,
		errno,
		ErrorMessages,
		Exact,
		gridStyle,
		HostLabels,
		ImageWidth,ImageHeight,
		IncludedSegments[],
		LineWidth,
		LineColor,
		MapDetail,
		MinimumStrokeSize,
		NoProlog,
		normalizeLongs,
		numIncludedSegments,
		NumHosts,
		NumPaths,
		NumColors,
		NumLayers,
		OmitDetails;
		PageWidth,PageHeight,PageMargin,CaptionMargin,
		Projection,
		RawPathCount,
		RotDegrees,
		showframe,
		SlotSize,
		SomeCircles,
		StrokeLimit,
		TrafficLW,
		UseGrid,UseNames,
		UsingCanned,
		XSlots,YSlots,
		Zmax;

extern double	
		CaptionAngle,
		CenterY,CenterX,
		ClipXmax,ClipXmin,ClipYmax,ClipYmin,
		Cutoff,
		fixlong(),slotx(),sloty(),
		gridincr,
		Lamb1,
		Lamb2,
		LatCenter,
		LatHeight,
		LatMin,LatMax,
		LongCenter,
		LongMin,LongMax,
		LongWidth,
		LongBasis,
		MapScale,
		MapScaleBase,
		rotate,
		RoughLongMin,RoughLongMax,RoughLatMin,RoughLatMax,
		RoughCrossDateline,
		ScaleFactor,
		scanlat(),
		Xslotinc,Yslotinc,
		Zhostmax;
extern char	WidthNames[5][4],
		profilename[],
		*colorNames[50];
extern short *cmap;
extern char ProgID[];
