%!
% PostScript profile for "netmap" program.
% Brian K. Reid, September 1986
% version 2.1: September 1991

% The following commands will be output literally as the EPSF header. Make
% sure that the font and bounding box in them matches what the following
% definitions will produce. The bounding box is produced by taking the
% paper size and subtracting the margin on all 4 sides. The "%%*" line 
% is a hack to trigger netmap to generate some stuff that is too variable
% to put into the profile.

%!PS-Adobe-2.0 EPSF-1.2
%%BoundingBox: 23 23 589 769
%%*
%%DocumentFonts: Helvetica-Bold Helvetica Courier Symbol
%%EndComments

% These next lines must be in a very strict format because they are read in
% by the netmap program as well as by PostScript. The format is 
% "/Name<space><integer><space>def"

% Note A4 paper is 595 x 842 points
/Pwid 595 def		% page width
/Pht 792 def		% page height
/Margin 23 def		% border margin
/CaptionMargin 25 def	% caption margin (at the bottom)
/Clw 15 def		% max-traffic line width

%%%%%%%%%% parameters to control feature size %%%%%%%%%%

% Cope with various sizes of paper 

Pht 792 gt 
    {statusdict /11x17tray known {
	statusdict begin 11x17tray end
    }{
	statusdict /setpageparams known {
	    11 72 mul 17 72 mul 36 1	% w h offs. orientation
	    statusdict begin setpageparams end
	}{
	    11 17 div dup scale		% for laserwriter
	} ifelse
    } ifelse
  } if

% point size of map title
/TitleSize 10 def

% point size of map subtitle
/SubtitleSize 7.5 def

% point size of body captions
/CaptionSize 8 def

% point size of grid-label captions
/GridLblSize 5 def	

% point size of city dot font (dot is .4 of ht)
/CityDotFontSize 12 def 

% font styles
/CaptionFont /Helvetica findfont def
/TitleFont   /Helvetica-Bold findfont def
/CityDotFont  /Courier findfont def
/HostNameFont /Courier findfont def
/ArrowFont    /Symbol findfont def

% Line widths (in points) for narrow, medium, wide, and extra-wide  lines.
/Nlw 0.25 def   /Mlw 0.5 def	/Wlw 1 def	/Xlw 1.5 def	/Zlw 2.5 def

% colors
/Colors 20 dict def
/cdef {exch dup 3 1 roll exch def} def
/Cmap [ 0
% the following line must not change; it is used as a flag by the netmap
% software so that the software can build a table of defined color names.
Colors begin
/Red [1 0 0] cdef
/Green [0 1 0] cdef
/Blue [0 0 1] cdef
/White [1 1 1] cdef
/Black [0 0 0] cdef
/Magenta [1 0 1] cdef
/Cyan [0 1 1] cdef
/Yellow [1 1 0] cdef
/Orange [1 .75 0] cdef
/Purple [.75 0 1] cdef
/Chartreuse [.75 1 0] cdef
/Fuschia [1 0 .75] cdef
/Azure [0 .75 1] cdef
/Mint [0 1 .75] cdef
/Brown [.7 .5 0] cdef
% the following line must say just "end"
end
 ] def

% ratio color1 color2 CMX (color mix)
/CMX {0 1 2 {dup
	  4 -1 roll dup 5 1 roll exch get exch
	  3 -1 roll dup 4 1 roll exch get exch
	  dup 3 1 roll sub 5 -1 roll dup 6 1 roll
	  mul add 4 1 roll
	} for pop pop pop setrgbcolor
       } def

/BGcolor {1 setgray} def	% background color
/FGcolor {0 setgray} def	% foreground color
/MFcolor {0 setgray} def	% map feature color
/CRcolor {0 setgray} def	% circle color
/CLcolor {0 setgray} def	% circle label color
/DTcolor {0 setgray} def	% dot color
/PHcolor {0 setgray} def	% path color
/LGcolor {0 setgray} def	% legend color

% global data
/DMX matrix defaultmatrix def
/MMX matrix def

% this sets the dot pattern for dotted lines
/DAR [1] def

% this sets the dash pattern for dashed lines
/DSR [5 1 1 1 1 1] def

% abbreviation procedures to shorten the file
/CF {scalefont setfont} bind def
/CL {curveto stroke} bind def
/DV {scf div} bind def
/L /lineto load def
/LX {currentpoint exch pop lineto} bind def
/LY {currentpoint pop exch lineto} bind def
/MP {moveto gsave currentpoint translate} bind def
/MB {lineto stroke grestore} bind def
/MI {currentpoint stroke newpath moveto} bind def
/MT /moveto load def
/NP /newpath load def 
/PL {lineto stroke} bind def
/R /rlineto load def
/ST {stroke grestore} bind def
/SCF {DV scalefont setfont} bind def
/SDW {DV setlinewidth DAR 0 setdash} bind def
/SFW {DV setlinewidth DSR 0 setdash} bind def
/SLW {[] 0  setdash DV setlinewidth} bind def
/SLC {Cmap exch get Colors begin load end aload pop setrgbcolor} def
/SPW {Clw mul [] 0  setdash DV setlinewidth 1 setlinecap} bind def
/X {0 rlineto} bind def
/Y {0 exch rlineto} bind def

/ntbl [ [/M /x /w /v /X /X /Z]
	[/y /s /m /U /i /J /X]
	[/z /q /h /u /e /n /V]
	[/A /W /l /X /r /E /T]
	[/B /p /g /d /f /o /S]
	[/C /t /k /D /j /K /Q]
	[/F /G /H /I /N /O /P] ] def
% define each element of the above matrix to be a shorthand move command.
0 1 6 {/rx exch def 0 1 6 {/cx exch def ntbl rx get cx get dup
       /X ne {[ cx 3 sub 3 rx sub /rlineto load] cvx bind def} {pop} ifelse
      } for } for

% exit from map scale to text scale, and turn off rotation
/GMCT {gsave moveto currentpoint transform
       DMX setmatrix itransform translate CaptionFont
       GridLblSize CF} bind def
/RSG {rotate 0 0.5 rmoveto show grestore} bind def

% exit from map scale to text scale, but keep current rotation
/GMT  {gsave transform 0 0 moveto 1 scf div dup scale} bind def

% draw black (BA) and white (WA and SWA) arrows along paths. 
/BA {gsave translate rotate 1 DV dup scale newpath 0.2 setlinewidth
     dup newpath dup 4 mul exch moveto 0 0 lineto dup 4 mul  exch neg lineto
     closepath fill grestore} bind def
/WA {gsave translate rotate BGcolor 1 DV dup scale newpath 0.2 setlinewidth
	5 2 moveto 0 0 lineto 5 -2 lineto 0 0 moveto 10 0 lineto
	BGcolor stroke grestore} bind def
% small white arrow
/SWA {gsave translate rotate 1 DV dup scale 0.2 setlinewidth 0.6 dup scale
	5 2 moveto 0 0 lineto 5 -2 lineto 0 0 moveto 10 0 lineto
	BGcolor stroke grestore} bind def

% draw a hostname circle and write the host name in it
/HST {gsave translate rotate 0 0 moveto 0 0 CxD DV 0 360 newpath arc
      gsave BGcolor fill grestore .25 SLW stroke
      dup length dup /HSTln exch def 4 le
      {dup stringwidth pop -2 div -1.5 DV moveto CLcolor show}
         {/HSTln HSTln 1 add 2 div cvi def
	  dup 0 HSTln getinterval dup stringwidth pop -2 div 0.5 DV moveto
	  show
          dup length HSTln sub HSTln exch getinterval
           dup stringwidth pop -2 div -3.7 DV moveto show
         } ifelse
      grestore} bind def

% draw a hostname circle, put the number in it, and write the name
/HTT {gsave translate gsave rotate 0 0 moveto 0 0 CxD DV 0 360 newpath arc
      gsave BGcolor fill grestore .25 SLW stroke
      dup stringwidth pop -2 div -1.5 DV moveto CLcolor show
      grestore rotate moveto HFn setfont show 
      grestore} bind def

% draw a dot representing a host location (but without a label)
% we do this with a font bullet instead of an arc so it will be cached
/Hd {/HDyy exch def /HDxx exch def HDxx HDyy 
	gsave translate CityDotFontSize DV dup -.3 mul exch -.3058 mul
	exch moveto (\267) show grestore} bind def
/Hr {HDxx HDyy moveto rmoveto currentpoint Hd} bind def
/Hx {0 exch Hr} bind def

/Id {gsave translate gsave CityDotFontSize DV dup -.3 mul exch -.3058 mul
	exch moveto (\267) DTcolor show grestore
	rotate moveto HFn setfont show
	grestore} bind def

% set up fonts for drawing circle text and node label text
/HF {HostNameFont [4 DV 0 0 6 DV 0 0] makefont} def
/IF {HostNameFont [4.5 DV 0 0 7 DV 0 0] makefont} def

% Utility procedure to draw a margin path, for decoration
/Mpath {newpath 0 0 moveto Pwid Margin 2 mul sub 0 rlineto 0 Pht
   Margin 2 mul CaptionMargin add sub rlineto Pwid Margin 2 mul sub neg 0
   rlineto closepath} bind def

% center text horizontally at the current point
/lctr {gsave zf setfont 10 mul 0 exch rmoveto dup
  stringwidth pop -2 div 0 rmoveto show grestore} bind def

% display text aligned left or right at the current point
/ldsp {/dr exch def gsave zf setfont dup stringwidth pop dr mul 0 rmoveto
	show grestore} bind def

% Print map title and subtitle and label information
/T1 {gsave MMX setmatrix
     0 -3 TitleSize sub MT TitleFont TitleSize CF show
     grestore} bind def
/T2 {gsave MMX setmatrix
     0 -5 TitleSize sub SubtitleSize sub MT TitleFont SubtitleSize CF show
     grestore} bind def
/MLB {290 -4 MT CaptionFont CaptionSize CF CaptionSize 1 add 
      mul neg 0 exch rmoveto show} bind def

% Functions for printing table of host names
/HSH {HSHx HSHy MT show /HSHy HSHy HSHdy sub def} def
/HSHmt {/HSHy exch def /HSHx exch def} def
/HSHdxy {/HSHdy exch def /HSHdx exch def} def

% per-page initialization
/INIT {Margin dup CaptionMargin add translate 
       MMX currentmatrix pop
	Mpath 1 setlinewidth
	gsave BGcolor fill grestore FGcolor stroke} def
 %%Endprofile
