#include "netmap.h"

/* ----------------------------------------------------------------------
   Fix a longitude to be in the range (-180,180].	 */

double fixlong(x) 
   double x;
{
    if (x > 180)  x -= 360.0;
    if (x <= -180) x += 360.0;
    return(x);
}

/* ----------------------------------------------------------------------
   Utility functions to pick apart a floating-point lat or long and
   return its integer and character componenrts.
 */

char NS(angle) double angle; {return( angle>0 ? 'N' : 'S' );}
char EW(angle) double angle; {return( angle>0 ? 'E' : 'W' );}

char *prll(angle,islat,wantspc) double angle; int islat,wantspc; {
    static char prlbuf[50];
    char *prlptr;
    int da,ma,sa,asec,ang;

   if (angle < 0) {
        asec = (int) trunc((angle*3600.0) - 0.5);
    } else {
	asec = (int) trunc((angle*3600.0) + 0.5);
    }
    ang = abs(asec) ;
    da = ang/3600;
/* the values of the variables "ma" and "sa" are getting set incorrectly. */
    ma = (ang / 60) % 60;
    sa = ang % 60;
    prlptr = &prlbuf[0];
    sprintf(prlptr,"%d",da);
    if (wantspc) sprintf(&prlbuf[strlen(prlbuf)],"\\312");
    if ((ma != 0) || (sa != 0)) {
        sprintf(&prlbuf[strlen(prlbuf)]," %d",ma);
        if (wantspc) sprintf(&prlbuf[strlen(prlbuf)],"\\302");
    }
    if (sa != 0) {
	sprintf(&prlbuf[strlen(prlbuf)]," %d",sa);
        if (wantspc) sprintf(&prlbuf[strlen(prlbuf)],"\\315");
    }
    prlptr = &prlbuf[strlen(prlbuf)];
    if (islat != 0) sprintf(prlptr,"%c",islat==1 ? NS(angle) : EW(angle));
    return (&prlbuf[0]);
}

/* ---------------------------------------------------------------------- */

initcheck(iflag,oletter,errflag)
int iflag,oletter,*errflag;
{
	if (!iflag) return;
	fprintf(stderr,"\nerror: cannot change -%c option after a file has been processed.\n",oletter);
	(*errflag)++;
}

/* ---------------------------------------------------------------------- */

/* Scan a latitude or longitude in degrees, minutes, and seconds. */
double scanlat(s)
char *s;
{
    char *cp;
    int pacifySaber=0;
    int i,p[3];
    cp = s;
    for(i=0; i<3; i++) p[i] = 0;
    i = 0;

    while (*cp == '.') {i++; cp++;}
    if (i > 2) return(0);
    while (!isspace(*cp)) {
	p[i++] = atoi(cp);
	if (i > 2) break;
	while (isdigit(*++cp)) {pacifySaber += *cp;};
	if (*cp++ != '.') break;
    }
    p[1] %= 60;
    p[2] %= 60;
    if (p[0] < 0) {p[1] = -p[1]; p[2] = -p[2];}
    return(p[0] +p[1]/60.0 + p[2]/3600.0);
}
